/*
 *  WeaponDArrow.cpp
 *  Knightmare
 *
 *  Created by Santi Ontañón on 11/6/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif

#include "Knightmare.h"

#include "WeaponDArrow.h"
#include "KObjectCreator.h"


WeaponDArrow::WeaponDArrow(int x,int y,int sfx_volume,GLTManager *GLTM, KPlayer *owner) : Weapon(x,y,sfx_volume,owner)
{
	int i;
	
	m_class = weapondarrow_symbol;
	
    m_n_states = 1;
    m_state_animations = new Animation *[1];
	
    for(i=0;i<1;i++) m_state_animations[i]=0;
	
    m_state = 0;
	
	Animation *a = new Animation(true);
	a->addFrame(GLTM->get("doublearrow_000001"),8);
	a->addFrame(GLTM->get("doublearrow_000002"),8);
	a->addFrame(GLTM->get("doublearrow_000003"),8);
	m_state_animations[0]=a;
	
}


WeaponDArrow::~WeaponDArrow() {
}


bool WeaponDArrow::cycle(List<VirtualController> *vcl, Knightmare *game, GLTManager *GLTM, SFXManager *SFXM)
{
	Weapon::cycle(vcl,game,GLTM,SFXM);
	
	m_y-=8.0f;
	
	if (m_y<game->get_map_position()-50) {
		m_owner->weaponDisappeared(this);
		return false;
	}
	
	if (game->get_map()->collisionWithTypes(this,0,0,game->getObstacleClasses())) {
		// Collision with a wall:
		// TODO: weapon destroyed effect
		m_owner->weaponDisappeared(this);
		return false;
	}
	
	
	return true;
}


bool WeaponDArrow::is_a(Symbol *c)
{
    if (c->cmp(weapondarrow_symbol))
        return true;
	
    return Weapon::is_a(c);
} /* WeaponDArrow::is_a */


bool WeaponDArrow::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);
	
    retval = is_a(s);
	
    delete s;
	
    return retval;
} /* WeaponDArrow::is_a */
